VERSION 5.00
Begin VB.Form Main 
   Caption         =   "USGS Sediment-Database Reader"
   ClientHeight    =   5475
   ClientLeft      =   5250
   ClientTop       =   3630
   ClientWidth     =   5880
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5475
   ScaleWidth      =   5880
   Begin VB.CommandButton USGS_Calculate 
      Caption         =   "Calculate"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   4560
      TabIndex        =   12
      Top             =   3840
      Width           =   1092
   End
   Begin VB.TextBox tb_ResultFile 
      Height          =   288
      Left            =   960
      TabIndex        =   4
      Top             =   120
      Width           =   3372
   End
   Begin VB.Frame frm_Status 
      Caption         =   "Status"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   612
      Left            =   120
      TabIndex        =   8
      Top             =   4560
      Width           =   4212
      Begin VB.Label lb_StatusShow 
         Caption         =   "0%"
         Height          =   252
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   3012
      End
   End
   Begin VB.CommandButton bt_Exit 
      Caption         =   "Exit"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   4560
      TabIndex        =   7
      Top             =   4800
      Width           =   1092
   End
   Begin VB.CommandButton bt_Info 
      Caption         =   "Info"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   4560
      TabIndex        =   6
      Top             =   4320
      Width           =   1092
   End
   Begin VB.Frame frm_FileInput 
      Caption         =   "File Manager"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3855
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   4212
      Begin VB.FileListBox dlb_File 
         Height          =   3210
         Left            =   2280
         MultiSelect     =   2  'Erweitert
         TabIndex        =   3
         Top             =   360
         Width           =   1695
      End
      Begin VB.DirListBox dlb_Directory 
         Height          =   2790
         Left            =   240
         TabIndex        =   2
         Top             =   840
         Width           =   1935
      End
      Begin VB.DriveListBox dlb_Drive 
         Height          =   288
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   1932
      End
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  '2D
      BackColor       =   &H8000000B&
      BorderStyle     =   0  'Kein
      FillColor       =   &H8000000B&
      ForeColor       =   &H8000000A&
      Height          =   3255
      Left            =   4680
      Picture         =   "USGS-Sediment.frx":0000
      ScaleHeight     =   3255
      ScaleWidth      =   975
      TabIndex        =   10
      Top             =   120
      Width           =   975
   End
   Begin VB.Label Lb_Copyright 
      Caption         =   "written by Holger Schuble 3/2002"
      Height          =   255
      Left            =   3240
      TabIndex        =   11
      Top             =   5280
      Width           =   2655
   End
   Begin VB.Label Lb_ResultFile 
      Caption         =   "Result:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   252
      Left            =   240
      TabIndex        =   5
      Top             =   120
      Width           =   852
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub USGS_Calculate_Click()          'Funktionsfhig, keine Fehler mehr, 26.9.2000
                                            'wichtig: Val() anstatt Csng() bei Stringumwandlung
'Variablendeklaration                       'Testboxen noch im Code, entaktiviert
    '''''''''''''''''''''
    Dim Datei, Zeile, ZeileMAX, LeerZaehler, StringStellen, Temp As Long
    Dim DateiName, Doppelzeichen, TempString, EinleseString, ExportString, ErrorString  As String
    Dim StationString, StandardString, MeanPosString, Q10String, C10String, L10String As String
    Dim PosDEG, PosMM, PosSS As Long
    Dim LeerZeichenPosition(9) As Long
    Dim Jahr, JahrMIN, JahrMAX As Integer
    Dim StationsArray(5) As String
    Dim QArr() As Single
    Dim CArr() As Single
    Dim LArr() As Single
    Dim Q10(11) As Single
    Dim C10(11) As Single
    Dim L10(11) As Single
    Dim Q95, Q99, C95, C99, L95, L99 As Single
    Dim Q_MeanPos, L_MeanPos, LM_MeanPos As Integer
    Dim Q_MeanDiff, L_MeanDiff, X_MeanTmp As Single
    Dim AbfluMEAN, LoadMEAN, SedimentYieldMEAN As Single
    Dim AbfluSTD, LoadSTD, SedimentYieldSTD As Single
    Dim AbfluSUM, LoadSUM, AbfluTEMP, LoadTEMP As Single
    Dim AbfluCOUNT, ConcCOUNT, LoadCOUNT As Long
    Dim Pos10, Start10 As Long
    
    'Initialisierungsaktionen
    '''''''''''''''''''''''''
    Screen.MousePointer = vbHourglass
    On Error GoTo ErrorMessage
    Open tb_ResultFile.Text For Output As #1
    StationString = "Name;ID;Area;Lat;Lon;Years;Start;End;File"
    StandardString = "Q_(cms);Qstd_(cms);L_(Mg/d);Lstd_(Mg/d);SSY_(T/qkm/a);SSYstd_(T/qkm/a)"
    Q10String = "Q_Num;Q_1;Q_10;Q_20;Q_30;Q_40;Q_50;Q_60;Q_70;Q_80;Q_90;Q_95;Q_99;Q_100"
    C10String = "C_Num;C_1;C_10;C_20;C_30;C_40;C_50;C_60;C_70;C_80;C_90;C_95;C_99;C_100"
    L10String = "L_Num;L_1;L_10;L_20;L_30;L_40;L_50;L_60;L_70;L_80;L_90;L_95;L_99;L_100"
    LM10String = "LM_Num;LM_1;LM_10;LM_20;LM_30;LM_40;LM_50;LM_60;LM_70;LM_80;LM_90;LM_95;LM_99;LM_100"
    MeanPosString = "Q_MeanPos;L_MeanPos;LM_MeanPos"
    ExportString = StationString & ";" & StandardString & ";" & Q10String & ";" & C10String & ";" & L10String & ";" & MeanPosString
    Print #1, ExportString
    
    'Auswertungsschleife
    ''''''''''''''''''''
    For Datei = 0 To dlb_File.ListCount - 1       'Abarbeitung jeder ausgewhlten Datei
        If dlb_File.Selected(Datei) Then          '####################################
        
            lb_StatusShow.Caption = "Actual file: " & dlb_File.List(Datei)    'Einlesen
            lb_StatusShow.Refresh
            Doppelzeichen = InStr(dlb_File.Path & "\", "\\")
            If Doppelzeichen > 0 Then
                DateiName = dlb_File.Path & dlb_File.List(Datei)
            Else
                DateiName = dlb_File.Path & "\" & dlb_File.List(Datei)
            End If
            
            Open DateiName For Input As #2
            ZeileMAX = 0                                'Ermittlung der Zeilenanzahl
            Do While Not EOF(2)                         'und Festsetzung der Arraygre
                Line Input #2, EinleseString            '##############################
                ZeileMAX = ZeileMAX + 1
            Loop
            Close #2
            ReDim QArr(ZeileMAX)
            ReDim CArr(ZeileMAX)
            ReDim LArr(ZeileMAX)
          
            Open DateiName For Input As #2          'Stationsinformationen und Berechnung
            For Zeile = 0 To 8                      '####################################
                Line Input #2, EinleseString
                Select Case Zeile           'Standardinformationen
                Case Is = 0         'Station Name
                    StationsArray(0) = Right(EinleseString, Len(EinleseString) - 25)
                Case Is = 1         'Station ID
                    StationsArray(1) = Right(EinleseString, Len(EinleseString) - 28)
                Case Is = 2         'Basin Area, Umrechnung in km2
                    StationsArray(2) = Format(Val(Mid(EinleseString, 23)) * 2.58984649, "0.00")
                    If StationsArray(2) = 0 Then
                        StationsArray(2) = -99
                    End If
                Case Is = 3         'Latitude, Umrechnung von dec.mm.ss nach Dezimalgrad
                    StationsArray(3) = Right(EinleseString, Len(EinleseString) - 29)
                    If Len(StationsArray(3)) <> 0 Then
                        PosDEG = CLng(StationsArray(3)) \ 10000
                        PosMM = (CLng(StationsArray(3)) Mod 10000) \ 100
                        PosSS = ((CLng(StationsArray(3)) Mod 10000) Mod 100)
                        StationsArray(3) = Format((PosDEG + PosMM / 60 + PosSS / 3600), "0.000000")
                    Else
                        StationsArray(3) = -99
                    End If
                Case Is = 4         'Longitude, Umrechnung von dec.mm.ss nach Dezimalgrad
                    StationsArray(4) = Right(EinleseString, Len(EinleseString) - 28)
                    If Len(StationsArray(4)) <> 0 Then
                        PosDEG = CLng(StationsArray(4)) \ 10000
                        PosMM = (CLng(StationsArray(4)) Mod 10000) \ 100
                        PosSS = ((CLng(StationsArray(4)) Mod 10000) Mod 100)
                        StationsArray(4) = Format((PosDEG + PosMM / 60 + PosSS / 3600) * -1, "0.000000")
                    Else
                        StationsArray(4) = -99
                    End If
                End Select
                QArr(Zeile) = -99
                CArr(Zeile) = -99
                LArr(Zeile) = -99
            Next Zeile
            
            JahrMAX = 0
            JahrMIN = 10000
            For Zeile = 9 To ZeileMAX - 1
                Line Input #2, EinleseString         'Einlesen der Stationsdaten (Messwerte)
                If EinleseString = "" Then           'in ein Array, zeilenweise Abarbeitung
                    Exit For                         '#####################################
                End If
                LeerZaehler = 0
                For Temp = 1 To Len(EinleseString)          'Ermittlung der Leerzeichenpositionen
                    Temp = InStr(Temp, EinleseString, " ")  'Rckgabe der Leerzeichenposition
                    LeerZaehler = LeerZaehler + 1
                    LeerZeichenPosition(LeerZaehler) = Temp
                Next Temp
                QArr(Zeile) = Val(Mid(EinleseString, LeerZeichenPosition(4), LeerZeichenPosition(5) - LeerZeichenPosition(4)))   'Abflu in cms
                CArr(Zeile) = Val(Mid(EinleseString, LeerZeichenPosition(5), LeerZeichenPosition(6) - LeerZeichenPosition(5))) 'SedimentKonzentration in mg/l
                LArr(Zeile) = Val(Mid(EinleseString, LeerZeichenPosition(7), LeerZeichenPosition(8) - LeerZeichenPosition(7))) 'Sedimentfracht in Md/day
                Jahr = Val(Mid(EinleseString, LeerZeichenPosition(1), LeerZeichenPosition(2) - LeerZeichenPosition(1)))     'Messjahr
                If Jahr < JahrMIN Then
                    JahrMIN = Jahr
                End If
                If Jahr > JahrMAX Then
                    JahrMAX = Jahr
                End If
            Next Zeile
            Close #2
            
            Quick_Sort QArr(), 0, ZeileMAX - 1      'Sortieren der Wertearrays
            Quick_Sort CArr(), 0, ZeileMAX - 1      '#########################
            Quick_Sort LArr(), 0, ZeileMAX - 1
            
            AbfluCOUNT = 0                     'Mean/Max-berechnung von
            ConcCOUNT = 0                       'Abflu/Sedimentfracht/Sedimentkonzentration
            LoadCOUNT = 0                       'und Sediment Yield
            AbfluSUM = 0                       '############################################
            LoadSUM = 0
            For Zeile = 9 To ZeileMAX - 1
                If QArr(Zeile) <> -99 Then
                    AbfluSUM = AbfluSUM + QArr(Zeile)
                    AbfluCOUNT = AbfluCOUNT + 1
                End If
                If CArr(Zeile) <> -99 Then
                    ConcCOUNT = ConcCOUNT + 1
                End If
                If LArr(Zeile) <> -99 Then
                    LoadSUM = LoadSUM + LArr(Zeile)
                    LoadCOUNT = LoadCOUNT + 1
                End If
            Next Zeile
            If AbfluCOUNT <> 0 Then
                AbfluMEAN = AbfluSUM / AbfluCOUNT
            Else
                AbfluMEAN = -99
            End If
            If LoadCOUNT <> 0 Then
                LoadMEAN = LoadSUM / LoadCOUNT
                If StationsArray(2) <> -99 Then
                    SedimentYieldMEAN = LoadMEAN * 365 / CDbl(StationsArray(2))
                    'MsgBox CDbl(StationsArray(2)), vbOKOnly, "Area"
                Else
                    SedimentYieldMEAN = -99
                End If
            Else
                LoadMEAN = -99
                SedimentYieldMEAN = -99
            End If
            
            Q_MeanDiff = 3.402823E+38
            L_MeanDiff = 3.402823E+38
            Q_MeanPos = -99
            L_MeanPos = -99
            AbfluTEMP = 0                     'Berechnung der Standardabweichung von Ab-
            LoadTEMP = 0                       'flu, Sedimentfracht und Sediment Yield
            For Zeile = 9 To ZeileMAX - 1      '#########################################
                If QArr(Zeile) <> -99 Then
                    AbfluTEMP = AbfluTEMP + (AbfluMEAN - QArr(Zeile)) ^ 2
                End If
                If LArr(Zeile) <> -99 Then
                    LoadTEMP = LoadTEMP + (LoadMEAN - LArr(Zeile)) ^ 2
                End If
                X_MeanTmp = Abs(QArr(Zeile) - AbfluMEAN)
                If X_MeanTmp < Q_MeanDiff Then
                    Q_MeanPos = Int(Zeile / (ZeileMAX - 1) * 100)
                    Q_MeanDiff = X_MeanTmp
                End If
                X_MeanTmp = Abs(LArr(Zeile) - LoadMEAN)
                If X_MeanTmp < L_MeanDiff Then
                    L_MeanPos = Int(Zeile / (ZeileMAX - 1) * 100)
                    L_MeanDiff = X_MeanTmp
                End If
            Next Zeile
            If AbfluMEAN <> -99 Then
                AbfluSTD = Sqr(AbfluTEMP / AbfluCOUNT)
            Else
                AbfluSTD = -99
            End If
            If LoadMEAN <> -99 Then
                LoadSTD = Sqr(LoadTEMP / LoadCOUNT)
                If StationsArray(2) <> -99 Then
                    SedimentYieldSTD = LoadSTD * 365 / CDbl(StationsArray(2))
                Else
                    SedimentYieldSTD = -99
                End If
            Else
                LoadSTD = -99
                SedimentYieldSTD = -99
            End If
            
            Start10 = ZeileMAX - AbfluCOUNT            'Dezentilberechnung Abflu
            For Temp = 1 To 9
                Pos10 = Start10 + Int((AbfluCOUNT / 10) * Temp)
                Q10(Temp) = QArr(Pos10)
            Next Temp
            Q10(10) = QArr(ZeileMAX - 1)
            Q10(0) = QArr(Start10)
            Q95 = QArr(Start10 + Int((AbfluCOUNT / 100) * 95))
            Q99 = QArr(Start10 + Int((AbfluCOUNT / 100) * 99))

            Start10 = ZeileMAX - ConcCOUNT              'Dezentilberechnung Konzentration
            For Temp = 1 To 9
                Pos10 = Start10 + Int((ConcCOUNT / 10) * Temp)
                C10(Temp) = CArr(Pos10)
            Next Temp
            C10(10) = CArr(ZeileMAX - 1)
            C10(0) = CArr(Start10)
            C95 = CArr(Start10 + Int((ConcCOUNT / 100) * 95))
            C99 = CArr(Start10 + Int((ConcCOUNT / 100) * 99))
            
            Start10 = ZeileMAX - LoadCOUNT              'Dezentilberechnung Sedimentfracht
            For Temp = 1 To 9
                Pos10 = Start10 + Int((LoadCOUNT / 10) * Temp)
                L10(Temp) = LArr(Pos10)
            Next Temp
            L10(10) = LArr(ZeileMAX - 1)
            L10(0) = LArr(Start10)
            L95 = LArr(Start10 + Int((LoadCOUNT / 100) * 95))
            L99 = LArr(Start10 + Int((LoadCOUNT / 100) * 99))
            
            StationString = StationsArray(0) & ";" & StationsArray(1) & ";" & StationsArray(2) & ";" & StationsArray(3) & ";" & StationsArray(4) & ";" & Format((ZeileMAX - 9) / 365, "0.0") & ";" & Format(JahrMIN, "0") & ";" & Format(JahrMAX, "0") & ";" & dlb_File.List(Datei)
            StandardString = Format(AbfluMEAN, "0.00") & ";" & Format(AbfluSTD, "0.00") & ";" & Format(LoadMEAN, "0.00") & ";" & Format(LoadSTD, "0.00") & ";" & Format(SedimentYieldMEAN, "0.00") & ";" & Format(SedimentYieldSTD, "0.00")
            Q10String = Format(AbfluCOUNT, "0") & ";" & Format(Q10(0), "0") & ";" & Format(Q10(1), "0") & ";" & Format(Q10(2), "0") & ";" & Format(Q10(3), "0") & ";" & Format(Q10(4), "0") & ";" & Format(Q10(5), "0") & ";" & Format(Q10(6), "0") & ";" & Format(Q10(7), "0") & ";" & Format(Q10(8), "0") & ";" & Format(Q10(9), "0") & ";" & Format(Q95, "0") & ";" & Format(Q99, "0") & ";" & Format(Q10(10), "0")
            C10String = Format(ConcCOUNT, "0") & ";" & Format(C10(0), "0") & ";" & Format(C10(1), "0") & ";" & Format(C10(2), "0") & ";" & Format(C10(3), "0") & ";" & Format(C10(4), "0") & ";" & Format(C10(5), "0") & ";" & Format(C10(6), "0") & ";" & Format(C10(7), "0") & ";" & Format(C10(8), "0") & ";" & Format(C10(9), "0") & ";" & Format(C95, "0") & ";" & Format(C99, "0") & ";" & Format(C10(10), "0")
            L10String = Format(LoadCOUNT, "0") & ";" & Format(L10(0), "0") & ";" & Format(L10(1), "0") & ";" & Format(L10(2), "0") & ";" & Format(L10(3), "0") & ";" & Format(L10(4), "0") & ";" & Format(L10(5), "0") & ";" & Format(L10(6), "0") & ";" & Format(L10(7), "0") & ";" & Format(L10(8), "0") & ";" & Format(L10(9), "0") & ";" & Format(L95, "0") & ";" & Format(L99, "0") & ";" & Format(L10(10), "0")
            MeanPosString = Format(Q_MeanPos, "0") & ";" & Format(L_MeanPos, "0")
            ExportString = StationString & ";" & StandardString & ";" & Q10String & ";" & C10String & ";" & L10String & ";" & MeanPosString
            Print #1, ExportString

        End If
    Next Datei
    
    'Beenden des Programms
    ''''''''''''''''''''''
    lb_StatusShow.Caption = "Calculation finished"
    lb_StatusShow.Refresh
    Screen.MousePointer = vbDefault
    Close
        
'Fehlerroutine
''''''''''''''
ErrorMessage:
If Err.Number > 0 Then
    Screen.MousePointer = vbDefault
    'MsgBox Err.Description, vbOKOnly, "Error Window"
    'ErrorString = AbfluMEAN & ";" & LoadMEAN & ";" & Zeile
    'MsgBox ErrorString, vbOKOnly, "Error"
    MsgBox "Wrong input files." & Chr(10) & Chr(13) & "Check them again, please.", vbOKOnly, "User Error"
    lb_StatusShow.Caption = "0%"
    lb_StatusShow.Refresh
    Close
End If

End Sub

Private Sub Quick_Sort(ByRef SortArray() As Single, ByVal First As Long, ByVal Last As Long)
  Dim Temp As Single, Low As Long, High As Long
  Dim List_Separator As Single
   
  Low = First
  High = Last
  List_Separator = SortArray((First + Last) / 2)
  Do
    Do While (SortArray(Low) < List_Separator)
       Low = Low + 1
    Loop
    Do While (SortArray(High) > List_Separator)
       High = High - 1
    Loop
    If (Low <= High) Then
        Temp = SortArray(Low)
        SortArray(Low) = SortArray(High)
        SortArray(High) = Temp
        Low = Low + 1
        High = High - 1
    End If
  Loop While (Low <= High)
  If (First < High) Then Quick_Sort SortArray, First, High
  If (Low < Last) Then Quick_Sort SortArray, Low, Last
End Sub


Private Sub bt_Exit_Click()
    End
End Sub

Private Sub bt_Info_Click()
    Load Info
    Info.Show
End Sub

Private Sub dlb_Directory_Change()
    dlb_File.Path = dlb_Directory.Path
        Dim Doppenzeichen As String
    Doppelzeichen = InStr(dlb_File.Path & "\", "\\")
    If Doppelzeichen > 0 Then
        tb_ResultFile.Text = dlb_File.Path & "usgs.sed"
    Else
        tb_ResultFile.Text = dlb_File.Path & "\usgs.sed"
    End If
End Sub
Private Sub dlb_Drive_Change()
    On Error GoTo ErrorMessage
    dlb_Directory.Path = dlb_Drive.Drive
ErrorMessage:
If Err.Number > 0 Then
    dlb_Drive.Drive = "C:"
    dlb_Directory.Path = "C:"
    MsgBox "Choosen drive not available," & Chr(10) & Chr(13) & "drive reset to C:", vbOKOnly, "User Error"
End If
End Sub
Private Sub Form_Load()
    dlb_File.Path = dlb_Directory.Path
        Dim Doppenzeichen As String
    Doppelzeichen = InStr(dlb_File.Path & "\", "\\")
    If Doppelzeichen > 0 Then
        tb_ResultFile.Text = dlb_File.Path & "usgs.sed"
    Else
        tb_ResultFile.Text = dlb_File.Path & "\usgs.sed"
    End If
End Sub

Private Sub USGS_Calculate_Month_Click()    'Funktionsfhig, keine Fehler mehr, 26.9.2000
                                            'wichtig: Val() anstatt Csng() bei Stringumwandlung
'Variablendeklaration                       'Testboxen noch im Code, entaktiviert
    '''''''''''''''''''''
    Dim Datei, Zeile, ZeileMAX, LeerZaehler, StringStellen, Temp As Long
    Dim DateiName, Doppelzeichen, TempString, EinleseString, ExportString, ErrorString  As String
    Dim StationString, StandardString, MeanPosString, Q10String, C10String, L10String As String
    Dim PosDEG, PosMM, PosSS As Long
    Dim LeerZeichenPosition(9) As Long
    Dim Jahr, JahrMIN, JahrMAX As Integer
    Dim StationsArray(5) As String
    Dim QArr() As Single
    Dim CArr() As Single
    Dim LArr() As Single
    Dim Q10(11) As Single
    Dim C10(11) As Single
    Dim L10(11) As Single
    Dim Q95, Q99, C95, C99, L95, L99 As Single
    Dim Q_MeanPos, L_MeanPos As Integer
    Dim Q_MeanDiff, L_MeanDiff, X_MeanTmp As Single
    Dim AbfluMEAN, LoadMEAN, SedimentYieldMEAN As Single
    Dim AbfluSTD, LoadSTD, SedimentYieldSTD As Single
    Dim AbfluSUM, LoadSUM, AbfluTEMP, LoadTEMP As Single
    Dim AbfluCOUNT, ConcCOUNT, LoadCOUNT As Long
    Dim Pos10, Start10 As Long
    
    'Initialisierungsaktionen
    '''''''''''''''''''''''''
    Screen.MousePointer = vbHourglass
    On Error GoTo ErrorMessage
    Open tb_ResultFile.Text For Output As #1
    StationString = "Name;ID;Area;Lat;Lon;Years;Start;End;File"
    StandardString = "Q_(cms);Qstd_(cms);L_(Mg/d);Lstd_(Mg/d);SSY_(T/qkm/a);SSYstd_(T/qkm/a)"
    Q10String = "Q_Num;Q_1;Q_10;Q_20;Q_30;Q_40;Q_50;Q_60;Q_70;Q_80;Q_90;Q_95;Q_99;Q_100"
    C10String = "C_Num;C_1;C_10;C_20;C_30;C_40;C_50;C_60;C_70;C_80;C_90;C_95;C_99;C_100"
    L10String = "L_Num;L_1;L_10;L_20;L_30;L_40;L_50;L_60;L_70;L_80;L_90;L_95;L_99;L_100"
    MeanPosString = "Q_MeanPos;L_MeanPos"
    ExportString = StationString & ";" & StandardString & ";" & Q10String & ";" & C10String & ";" & L10String & ";" & MeanPosString
    Print #1, ExportString
    
    'Auswertungsschleife
    ''''''''''''''''''''
    For Datei = 0 To dlb_File.ListCount - 1       'Abarbeitung jeder ausgewhlten Datei
        If dlb_File.Selected(Datei) Then          '####################################
        
            lb_StatusShow.Caption = "Actual file: " & dlb_File.List(Datei)    'Einlesen
            lb_StatusShow.Refresh
            Doppelzeichen = InStr(dlb_File.Path & "\", "\\")
            If Doppelzeichen > 0 Then
                DateiName = dlb_File.Path & dlb_File.List(Datei)
            Else
                DateiName = dlb_File.Path & "\" & dlb_File.List(Datei)
            End If
            
            Open DateiName For Input As #2
            ZeileMAX = 0                                'Ermittlung der Zeilenanzahl
            Do While Not EOF(2)                         'und Festsetzung der Arraygre
                Line Input #2, EinleseString            '##############################
                ZeileMAX = ZeileMAX + 1
            Loop
            Close #2
            ReDim QArr(ZeileMAX)
            ReDim CArr(ZeileMAX)
            ReDim LArr(ZeileMAX)
          
            Open DateiName For Input As #2          'Stationsinformationen und Berechnung
            For Zeile = 0 To 8                      '####################################
                Line Input #2, EinleseString
                Select Case Zeile           'Standardinformationen
                Case Is = 0         'Station Name
                    StationsArray(0) = Right(EinleseString, Len(EinleseString) - 25)
                Case Is = 1         'Station ID
                    StationsArray(1) = Right(EinleseString, Len(EinleseString) - 28)
                Case Is = 2         'Basin Area, Umrechnung in km2
                    StationsArray(2) = Format(Val(Mid(EinleseString, 23)) * 2.58984649, "0.00")
                    If StationsArray(2) = 0 Then
                        StationsArray(2) = -99
                    End If
                Case Is = 3         'Latitude, Umrechnung von dec.mm.ss nach Dezimalgrad
                    StationsArray(3) = Right(EinleseString, Len(EinleseString) - 29)
                    If Len(StationsArray(3)) <> 0 Then
                        PosDEG = CLng(StationsArray(3)) \ 10000
                        PosMM = (CLng(StationsArray(3)) Mod 10000) \ 100
                        PosSS = ((CLng(StationsArray(3)) Mod 10000) Mod 100)
                        StationsArray(3) = Format((PosDEG + PosMM / 60 + PosSS / 3600), "0.000000")
                    Else
                        StationsArray(3) = -99
                    End If
                Case Is = 4         'Longitude, Umrechnung von dec.mm.ss nach Dezimalgrad
                    StationsArray(4) = Right(EinleseString, Len(EinleseString) - 28)
                    If Len(StationsArray(4)) <> 0 Then
                        PosDEG = CLng(StationsArray(4)) \ 10000
                        PosMM = (CLng(StationsArray(4)) Mod 10000) \ 100
                        PosSS = ((CLng(StationsArray(4)) Mod 10000) Mod 100)
                        StationsArray(4) = Format((PosDEG + PosMM / 60 + PosSS / 3600) * -1, "0.000000")
                    Else
                        StationsArray(4) = -99
                    End If
                End Select
                QArr(Zeile) = -99
                CArr(Zeile) = -99
                LArr(Zeile) = -99
            Next Zeile
            
            JahrMAX = 0
            JahrMIN = 10000
            For Zeile = 9 To ZeileMAX - 1
                Line Input #2, EinleseString         'Einlesen der Stationsdaten (Messwerte)
                If EinleseString = "" Then           'in ein Array, zeilenweise Abarbeitung
                    Exit For                         '#####################################
                End If
                LeerZaehler = 0
                For Temp = 1 To Len(EinleseString)          'Ermittlung der Leerzeichenpositionen
                    Temp = InStr(Temp, EinleseString, " ")  'Rckgabe der Leerzeichenposition
                    LeerZaehler = LeerZaehler + 1
                    LeerZeichenPosition(LeerZaehler) = Temp
                Next Temp
                QArr(Zeile) = Val(Mid(EinleseString, LeerZeichenPosition(4), LeerZeichenPosition(5) - LeerZeichenPosition(4)))   'Abflu in cms
                CArr(Zeile) = Val(Mid(EinleseString, LeerZeichenPosition(5), LeerZeichenPosition(6) - LeerZeichenPosition(5))) 'SedimentKonzentration in mg/l
                LArr(Zeile) = Val(Mid(EinleseString, LeerZeichenPosition(7), LeerZeichenPosition(8) - LeerZeichenPosition(7))) 'Sedimentfracht in Md/day
                Jahr = Val(Mid(EinleseString, LeerZeichenPosition(1), LeerZeichenPosition(2) - LeerZeichenPosition(1)))     'Messjahr
                If Jahr < JahrMIN Then
                    JahrMIN = Jahr
                End If
                If Jahr > JahrMAX Then
                    JahrMAX = Jahr
                End If
            Next Zeile
            Close #2
            
            Quick_Sort QArr(), 0, ZeileMAX - 1      'Sortieren der Wertearrays
            Quick_Sort CArr(), 0, ZeileMAX - 1      '#########################
            Quick_Sort LArr(), 0, ZeileMAX - 1
            
            AbfluCOUNT = 0                     'Mean/Max-berechnung von
            ConcCOUNT = 0                       'Abflu/Sedimentfracht/Sedimentkonzentration
            LoadCOUNT = 0                       'und Sediment Yield
            AbfluSUM = 0                       '############################################
            LoadSUM = 0
            For Zeile = 9 To ZeileMAX - 1
                If QArr(Zeile) <> -99 Then
                    AbfluSUM = AbfluSUM + QArr(Zeile)
                    AbfluCOUNT = AbfluCOUNT + 1
                End If
                If CArr(Zeile) <> -99 Then
                    ConcCOUNT = ConcCOUNT + 1
                End If
                If LArr(Zeile) <> -99 Then
                    LoadSUM = LoadSUM + LArr(Zeile)
                    LoadCOUNT = LoadCOUNT + 1
                End If
            Next Zeile
            If AbfluCOUNT <> 0 Then
                AbfluMEAN = AbfluSUM / AbfluCOUNT
            Else
                AbfluMEAN = -99
            End If
            If LoadCOUNT <> 0 Then
                LoadMEAN = LoadSUM / LoadCOUNT
                If StationsArray(2) <> -99 Then
                    SedimentYieldMEAN = LoadMEAN * 365 / CDbl(StationsArray(2))
                    'MsgBox CDbl(StationsArray(2)), vbOKOnly, "Area"
                Else
                    SedimentYieldMEAN = -99
                End If
            Else
                LoadMEAN = -99
                SedimentYieldMEAN = -99
            End If
            
            Q_MeanDiff = 3.402823E+38
            L_MeanDiff = 3.402823E+38
            Q_MeanPos = -99
            L_MeanPos = -99
            AbfluTEMP = 0                     'Berechnung der Standardabweichung von Ab-
            LoadTEMP = 0                       'flu, Sedimentfracht und Sediment Yield
            For Zeile = 9 To ZeileMAX - 1      '#########################################
                If QArr(Zeile) <> -99 Then
                    AbfluTEMP = AbfluTEMP + (AbfluMEAN - QArr(Zeile)) ^ 2
                End If
                If LArr(Zeile) <> -99 Then
                    LoadTEMP = LoadTEMP + (LoadMEAN - LArr(Zeile)) ^ 2
                End If
                X_MeanTmp = Abs(QArr(Zeile) - AbfluMEAN)
                If X_MeanTmp < Q_MeanDiff Then
                    Q_MeanPos = Int(Zeile / (ZeileMAX - 1) * 100)
                    Q_MeanDiff = X_MeanTmp
                End If
                X_MeanTmp = Abs(LArr(Zeile) - LoadMEAN)
                If X_MeanTmp < L_MeanDiff Then
                    L_MeanPos = Int(Zeile / (ZeileMAX - 1) * 100)
                    L_MeanDiff = X_MeanTmp
                End If
            Next Zeile
            If AbfluMEAN <> -99 Then
                AbfluSTD = Sqr(AbfluTEMP / AbfluCOUNT)
            Else
                AbfluSTD = -99
            End If
            If LoadMEAN <> -99 Then
                LoadSTD = Sqr(LoadTEMP / LoadCOUNT)
                If StationsArray(2) <> -99 Then
                    SedimentYieldSTD = LoadSTD * 365 / CDbl(StationsArray(2))
                Else
                    SedimentYieldSTD = -99
                End If
            Else
                LoadSTD = -99
                SedimentYieldSTD = -99
            End If
            
            Start10 = ZeileMAX - AbfluCOUNT            'Dezentilberechnung Abflu
            For Temp = 1 To 9
                Pos10 = Start10 + Int((AbfluCOUNT / 10) * Temp)
                Q10(Temp) = QArr(Pos10)
            Next Temp
            Q10(10) = QArr(ZeileMAX - 1)
            Q10(0) = QArr(Start10)
            Q95 = QArr(Start10 + Int((AbfluCOUNT / 100) * 95))
            Q99 = QArr(Start10 + Int((AbfluCOUNT / 100) * 99))

            Start10 = ZeileMAX - ConcCOUNT              'Dezentilberechnung Konzentration
            For Temp = 1 To 9
                Pos10 = Start10 + Int((ConcCOUNT / 10) * Temp)
                C10(Temp) = CArr(Pos10)
            Next Temp
            C10(10) = CArr(ZeileMAX - 1)
            C10(0) = CArr(Start10)
            C95 = CArr(Start10 + Int((ConcCOUNT / 100) * 95))
            C99 = CArr(Start10 + Int((ConcCOUNT / 100) * 99))
            
            Start10 = ZeileMAX - LoadCOUNT              'Dezentilberechnung Sedimentfracht
            For Temp = 1 To 9
                Pos10 = Start10 + Int((LoadCOUNT / 10) * Temp)
                L10(Temp) = LArr(Pos10)
            Next Temp
            L10(10) = LArr(ZeileMAX - 1)
            L10(0) = LArr(Start10)
            L95 = LArr(Start10 + Int((LoadCOUNT / 100) * 95))
            L99 = LArr(Start10 + Int((LoadCOUNT / 100) * 99))
            
            StationString = StationsArray(0) & ";" & StationsArray(1) & ";" & StationsArray(2) & ";" & StationsArray(3) & ";" & StationsArray(4) & ";" & Format((ZeileMAX - 9) / 365, "0.0") & ";" & Format(JahrMIN, "0") & ";" & Format(JahrMAX, "0") & ";" & dlb_File.List(Datei)
            StandardString = Format(AbfluMEAN, "0.00") & ";" & Format(AbfluSTD, "0.00") & ";" & Format(LoadMEAN, "0.00") & ";" & Format(LoadSTD, "0.00") & ";" & Format(SedimentYieldMEAN, "0.00") & ";" & Format(SedimentYieldSTD, "0.00")
            Q10String = Format(AbfluCOUNT, "0") & ";" & Format(Q10(0), "0") & ";" & Format(Q10(1), "0") & ";" & Format(Q10(2), "0") & ";" & Format(Q10(3), "0") & ";" & Format(Q10(4), "0") & ";" & Format(Q10(5), "0") & ";" & Format(Q10(6), "0") & ";" & Format(Q10(7), "0") & ";" & Format(Q10(8), "0") & ";" & Format(Q10(9), "0") & ";" & Format(Q95, "0") & ";" & Format(Q99, "0") & ";" & Format(Q10(10), "0")
            C10String = Format(ConcCOUNT, "0") & ";" & Format(C10(0), "0") & ";" & Format(C10(1), "0") & ";" & Format(C10(2), "0") & ";" & Format(C10(3), "0") & ";" & Format(C10(4), "0") & ";" & Format(C10(5), "0") & ";" & Format(C10(6), "0") & ";" & Format(C10(7), "0") & ";" & Format(C10(8), "0") & ";" & Format(C10(9), "0") & ";" & Format(C95, "0") & ";" & Format(C99, "0") & ";" & Format(C10(10), "0")
            L10String = Format(LoadCOUNT, "0") & ";" & Format(L10(0), "0") & ";" & Format(L10(1), "0") & ";" & Format(L10(2), "0") & ";" & Format(L10(3), "0") & ";" & Format(L10(4), "0") & ";" & Format(L10(5), "0") & ";" & Format(L10(6), "0") & ";" & Format(L10(7), "0") & ";" & Format(L10(8), "0") & ";" & Format(L10(9), "0") & ";" & Format(L95, "0") & ";" & Format(L99, "0") & ";" & Format(L10(10), "0")
            MeanPosString = Format(Q_MeanPos, "0") & ";" & Format(L_MeanPos, "0")
            ExportString = StationString & ";" & StandardString & ";" & Q10String & ";" & C10String & ";" & L10String & ";" & MeanPosString
            Print #1, ExportString

        End If
    Next Datei
    
    'Beenden des Programms
    ''''''''''''''''''''''
    lb_StatusShow.Caption = "Calculation finished"
    lb_StatusShow.Refresh
    Screen.MousePointer = vbDefault
    Close
        
'Fehlerroutine
''''''''''''''
ErrorMessage:
If Err.Number > 0 Then
    Screen.MousePointer = vbDefault
    'MsgBox Err.Description, vbOKOnly, "Error Window"
    'ErrorString = AbfluMEAN & ";" & LoadMEAN & ";" & Zeile
    'MsgBox ErrorString, vbOKOnly, "Error"
    MsgBox "Wrong input files." & Chr(10) & Chr(13) & "Check them again, please.", vbOKOnly, "User Error"
    lb_StatusShow.Caption = "0%"
    lb_StatusShow.Refresh
    Close
End If

End Sub
